routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

/**
 * Officer Routes
 */
Route::prefix('/officer')->group(function () {
    Route::namespace('Auth\Officer')->group(function () {
        Route::get('/login', 'LoginController@showLoginForm')->name('officer.login')->middleware('guest');
        Route::post('/login', 'LoginController@login')->middleware('guest');
        Route::get('/logout', 'LoginController@logout')->middleware('auth:web-officer')->name('officer.logout');
    });

    Route::namespace('Officer')->group(function () {
        Route::middleware('auth:web-officer')->group(function () {
            Route::get('/list', 'OfficerController@list')->name('officer.list');

            Route::resource('/book', 'BookController', [
                'only' => [
                    'index', 'create'
                ],
                'names' => [
                    'index' => 'officer.book',
                    'create' => 'officer.book.create'
                ]
            ]);
    
            Route::resource('/book/lending', 'BookLendingController', [
                'only' => [
                    'index', 'create'
                ],
                'names' => [
                    'index' => 'officer.book.lending',
                    'create' => 'officer.book.lending.create'
                ]
            ]);
    
            Route::resource('/book/return', 'BookReturnController', [
                'only' => [
                    'index', 'create'
                ],
                'names' => [
                    'index' => 'officer.book.return',
                    'create' => 'officer.book.return.create'
                ]
            ]);

            Route::resource('/member', 'MemberController', [
                'only' => [
                    'index', 'edit'
                ],
                'names' => [
                    'index' => 'officer.member',
                    'edit' => 'officer.member.edit'
                ]
            ]);           
        });
    });    
});
Route::resource('/officer', 'Officer\OfficerController', [
    'only' => [
        'index', 'edit'
    ],
    'names' => [
        'index' => 'officer.home',
        'edit' => 'officer.edit'
    ]
])->middleware('auth:web-officer');

/**
 * Member Routes
 */
Route::prefix('/member')->group(function () {
    Route::namespace('Auth\Member')->group(function () {
        // Route::get('/login', 'LoginController@showLoginForm')->name('member.login');
        // Route::post('/login', 'LoginController@login');


        Route::middleware('auth:web-member')->group(function () {
            Route::get('/', function() {
                //return view('pages.member.home');
            })->name('member.home');
        });
    });
});

app/Book.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Book extends Model
{
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = "books";

    /**
     * Indicates if the model should be timestamped.
     *
     * @var bool
     */
    public $timestamps = true;

    /**
     * hasMany to BookLending
     */
    public function loans()
    {
        return $this->hasMany('App\BookLending', 'book_id', 'id');
    }     
}

app/Officer.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class Officer extends Authenticatable
{
    use Notifiable;

    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = "officers";

    /**
     * Indicates if the model should be timestamped.
     *
     * @var bool
     */
    public $timestamps = true;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'username', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token', 'api_token',
    ];

    /**
     * hasMany to BookLending
     */
    public function loans()
    {
        return $this->hasMany('App\BookLending', 'officer_id', 'id');
    }

    /**
     * hasMany to BookReturn
     */
    public function returns() 
    {
        return $this->hasMany('App\BookReturn', 'officer_id', 'id');
    }  
}

app/Http/Controllers/Api/BookController.php
<?php

namespace App\Http\Controllers\API;

use App\Book;
use App\Http\Resources\BookResource;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class BookController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Book $book)
    {
        return BookResource::collection($book->all());
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $book = new Book;

        $book->isbn = $request->isbn;
        $book->title = $request->title;
        $book->description = $request->description;
        $book->categories = $request->categories;
        $book->creator = $request->creator;
        $book->publisher = $request->publisher;
        $book->stock = $request->stock;

        return response()->json($book->save());
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function show(Book $book)
    {
        return new BookResource($book);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Book $book)
    {
        $book->isbn = $request->isbn;
        $book->title = $request->title;
        $book->description = $request->description;
        $book->categories = $request->categories;
        $book->creator = $request->creator;
        $book->publisher = $request->publisher;
        $book->stock = $request->stock;

        return response()->json($book->save());
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function destroy(Book $book)
    {
        return response()->json($book->delete());
    }
}

app/Http/Controllers/Api/OfficerController.php
<?php

namespace App\Http\Controllers\API;

use App\Officer;
use App\Http\Resources\OfficerResource;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class OfficerController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Officer $officer)
    {
        return OfficerResource::collection($office->all());
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Officer  $officer
     * @return \Illuminate\Http\Response
     */
    public function show(Officer $officer)
    {
        return new OfficerResource($office);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Officer  $officer
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Officer $officer)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Officer  $officer
     * @return \Illuminate\Http\Response
     */
    public function destroy(Officer $officer)
    {
        //
    }
}

app/Http/Controllers/Officer/BookController.php
<?php

namespace App\Http\Controllers\Officer;

use App\Http\Controllers\Controller;
use App\Book;
use Illuminate\Http\Request;

class BookController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('pages.officer.book.book');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.officer.book.bookForm');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function show(Book $book)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function edit(Book $book)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Book $book)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function destroy(Book $book)
    {
        //
    }
}

app/Http/Controllers/Officer/BookLendingController.php
<?php

namespace App\Http\Controllers\Officer;

use App\Http\Controllers\Controller;
use App\BookLending;
use Illuminate\Http\Request;

class BookLendingController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('pages.officer.book.lending');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.officer.book.lendingForm');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\BookLending  $bookLending
     * @return \Illuminate\Http\Response
     */
    public function show(BookLending $bookLending)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\BookLending  $bookLending
     * @return \Illuminate\Http\Response
     */
    public function edit(BookLending $bookLending)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\BookLending  $bookLending
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, BookLending $bookLending)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\BookLending  $bookLending
     * @return \Illuminate\Http\Response
     */
    public function destroy(BookLending $bookLending)
    {
        //
    }
}

app/Http/Controllers/Officer/BookReturnController.php
<?php

namespace App\Http\Controllers\Officer;

use App\Http\Controllers\Controller;
use App\BookReturn;
use App\BookLending;
use App\Book;
use Illuminate\Http\Request;

class BookReturnController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('pages.officer.book.return');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.officer.book.returnForm');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\BookReturn  $bookReturn
     * @return \Illuminate\Http\Response
     */
    public function show(BookReturn $bookReturn)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\BookReturn  $bookReturn
     * @return \Illuminate\Http\Response
     */
    public function edit(BookReturn $bookReturn)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\BookReturn  $bookReturn
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, BookReturn $bookReturn)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\BookReturn  $bookReturn
     * @return \Illuminate\Http\Response
     */
    public function destroy(BookReturn $bookReturn)
    {
        //
    }
}

app/Http/Controllers/Officer/MemberController.php
<?php

namespace App\Http\Controllers\Officer;

use App\Http\Controllers\Controller;
use App\Member;
use Illuminate\Http\Request;

class MemberController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('pages.officer.home');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Member  $member
     * @return \Illuminate\Http\Response
     */
    public function show(Member $member)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Member  $member
     * @return \Illuminate\Http\Response
     */
    public function edit(Member $member)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Member  $member
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Member $member)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Member  $member
     * @return \Illuminate\Http\Response
     */
    public function destroy(Member $member)
    {
        //
    }
}

app/Http/Controllers/Officer/OfficerController.php
<?php

namespace App\Http\Controllers\Officer;

use App\Http\Controllers\Controller;
use App\Officer;
use Illuminate\Http\Request;

class OfficerController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('pages.officer.home');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function list()
    {
        return view('pages.officer.home');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Officer  $officer
     * @return \Illuminate\Http\Response
     */
    public function show(Officer $officer)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Officer  $officer
     * @return \Illuminate\Http\Response
     */
    public function edit(Officer $officer)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Officer  $officer
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Officer $officer)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Officer  $officer
     * @return \Illuminate\Http\Response
     */
    public function destroy(Officer $officer)
    {
        //
    }
}

resources/views/pages/officer/book/lending.blade.php
@extends('main')

@section('title', 'Officer - Books Lending')
@section('sidenav', 'true')
@section('content')
    <div class="card-panel white">
        <div class="fixed-action-btn horizontal">
            <a href="{{ route('officer.book.lending.create') }}" class="btn-floating btn-large waves-effect waves-light red"><i class="large material-icons">add</i></a>
        </div>

        <!-- Table -->
        <table id="table-book-lending" class="display" width="100%"></table>
        
        <!-- Modal Structure -->
        <div id="modal-actions" class="modal bottom-sheet">
          <div class="modal-content">
            <h4>What you will do ? <span id="selected-id" class="badge teal-text"></span></h4>
            <ul id="actions" class="collection">
                <a href="#!" id="return" class="collection-item">Return</a>
                <a href="#!" id="update" class="collection-item">Update</a>
                <a href="#!" id="destroy" class="collection-item">Destroy</a>
            </ul>
          </div>
        </div>

        <!-- Modal Structure -->
        <div id="modal-return" class="modal">
            <div class="modal-content">
                <h4>Return Book</h4>
                <p>Are you sure ???</p>
            </div>
            <div class="modal-footer">
                <a href="#!" class=" modal-action modal-close waves-effect waves-red btn-flat">Cancel</a>
                <a href="#!" class=" modal-action modal-close waves-effect waves-green btn-flat">Yes</a>
            </div>
        </div>
        
        <!-- Modal Structure -->
        <div id="modal-update" class="modal">
            <div class="modal-content">
                <h4>Update Form</h4>
                <p>A bunch of text</p>
            </div>
            <div class="modal-footer">
                <a href="#!" id="modal-cancel" class=" modal-action modal-close waves-effect waves-red btn-flat">Cancel</a>
                <a href="#!" id="modal-submit" class=" modal-action modal-close waves-effect waves-green btn-flat">Submit</a>
            </div>
        </div>

        <!-- Modal Structure -->
        <div id="modal-destroy" class="modal">
            <div class="modal-content">
                <h4>Destroy Data</h4>
                <p>Are you sure want delete this data ?</p>
            </div>
            <div class="modal-footer">
                <a href="#!" class=" modal-action modal-close waves-effect waves-red btn-flat">Cancel</a>
                <a href="#!" class=" modal-action modal-close waves-effect waves-green btn-flat">Yes</a>
            </div>
        </div>
    </div>
@endsection

@push('scripts')
    <script>
        $(document).ready(function () { 
            getData("{{ route('api.officer.book.lending') }}", success)

            function return_book(data) {
                
            }

            function update(data) {
                
            }

            function destroy(data) {
                
            }

            function success(response) {
                var table = $('#table-book-lending').DataTable({
                    dom: 'Bfrtip',
                    data: response.data,
                    columns: [
                        {title: 'ID', data: 'id'},
                        {title: 'Date Loan', data: 'date_loan'},
                        {title: 'Date Period', data: 'date_period'},
                        {title: 'Status', data: 'status'},
                        {title: 'Book ID', data: 'book.id'},
                        {title: 'Book ISBN', data: 'book.isbn'},
                        {title: 'Book Title', data: 'book.title'},
                        {title: 'Member ID', data: 'member.id'},
                        {title: 'Member NIS', data: 'member.nis'},
                        {title: 'Member Name', data: 'member.name'},
                        {title: 'Officer ID', data: 'officer.id'},
                        {title: 'Officer Name', data: 'officer.name'}
                    ],
                    responsive: true,
                    buttons: ['pdf', 'excel']
                })

                table.on('click', 'tr', function () { 
                    var selected = table.row(this).data()
                    console.log(selected)

                    var modal_actions = $('#modal-actions')
                        modal_actions.modal('open')
                        modal_actions.find('#selected-id').text(
                            "Loan ID:"+selected.id+
                            " Book ID:"+selected.book.id+
                            " Member ID:"+selected.member.id
                        )

                    modal_actions.find('ul > a').click(function () { 
                        if($(this).is('#return')) {
                            return_book(selected)
                        }
                        if($(this).is('#update')) {
                            update(selected)
                        }
                        if($(this).is('#destroy')) {
                            destroy(selected)
                        }
                    })                      
                })
            }
        })
    </script>
@endpush

resources/views/pages/officer/book/lendingForm.blade.php
@extends('main')

@section('title', 'Officer - Create Book Lending')
@section('sidenav', 'true')
@section('content')
    <div class="container">
        <div class="card-panel white">  
            <h4>Form Create Book Loan</h4>
            <form id="book-lending" action="" method="POST">
                {{ method_field('POST') }}
                {{ csrf_field() }}
                <input type="hidden" id="officer_id" class="validate" name="officer_id" value="{{ Auth::user()->id }}">

                <div class="row">
                    <div class="input-field col s12">
                        <input type="text" id="book_id" class="validate" name="book_id">
                        <label for="book_id">Book ID</label>
                    </div>
                    <div class="input-field col s12">
                        <input type="text" id="book_isbn" class="validate" disabled>                
                    </div>
                    <div class="input-field col s12">
                        <input type="text" id="book_title" class="validate" disabled>                    
                    </div>
                    <div class="input-field col s12">
                        <input type="text" id="member_id" class="validate" name="member_id">
                        <label for="member_id">Member ID</label>
                    </div>
                    <div class="input-field col s12">
                        <input type="text" id="member_nis" class="validate" disabled>                
                    </div>
                    <div class="input-field col s12">
                        <input type="text" id="member_name" class="validate" disabled>                
                    </div>                
                    <div class="col s12">         
                        Status           
                        <label>
                            <input type="radio" class="loan_status" name="status" value="borrowed">
                            <span>Borrowed</span>
                        </label>
                        <label>
                            <input type="radio" class="loan_status" name="status" value="returned">
                            <span>Returned</span>
                        </label>
                    </div>                                
                </div>
                <hr/>                
                <button class="btn waves-effect waves-light" type="submit" name="action">Submit
                    <i class="material-icons right">send</i>
                </button>
            </form>        
        </div>        
    </div>
@endsection
@push('scripts')
    <script>
        var form = $('#book-lending')

        form.find('#book_id').change(function () {

            getData("{{ url('api/officer/book') }}/"+$(this).val(), function (response) { 
                form.find('#book_isbn').val(response.data.isbn)
                form.find('#book_title').val(response.data.title)
            })
        })

        form.find('#member_id').change(function () { 
            getData("{{ url('api/officer/member') }}/"+$(this).val(), function (response) { 
                form.find('#member_nis').val(response.data.nis)
                form.find('#member_name').val(response.data.name)
            })
        })
        
        form.submit(function (event) { 
            event.preventDefault()
            console.log($(this).serialize())
            postData("{{ route('api.officer.book.lending.store') }}", $(this).serialize(), 
                function (response) { 
                    M.toast({
                        html: "Success",
                        outDuration: 1000,
                        classes: 'rounded',
                        completeCallback: function () { 
                            form.trigger('reset')
                        }
                    })
                }, 
                function (error) { 
                    M.toast({
                        html: "Error: "+error.statusText,
                        outDuration: 1000,
                        classes: 'rounded',
                        completeCallback: function () { 
                            console.log(error)
                        }
                    })
                }
            )
        })        
    </script>
@endpush

resources/views/pages/officer/book/return.blade.php
@extends('main')

@section('title', 'Officer - Books Lending')
@section('sidenav', 'true')
@section('content')
    <div class="card-panel white">
        <div class="fixed-action-btn horizontal">
            <a href="{{ route('officer.book.return.create') }}" class="btn-floating btn-large waves-effect waves-light red"><i class="large material-icons">add</i></a>
        </div>

        <!-- Table -->
        <table id="table-book-return" class="display" width="100%"></table>
        
        <!-- Modal Structure -->
        <div id="modal-actions" class="modal bottom-sheet">
          <div class="modal-content">
            <h4>What you will do ? <span id="selected-id" class="badge teal-text"></span></h4>
            <ul id="actions" class="collection">
                <a href="#!" id="borrow" class="collection-item">Borrow</a>
                <a href="#!" id="update" class="collection-item">Update</a>
                <a href="#!" id="destroy" class="collection-item">Destroy</a>
            </ul>
          </div>
        </div>
    </div>
@endsection

@push('scripts')
    <script>
        $(document).ready(function () { 
            getData("{{ route('api.officer.book.return') }}", success)

            function success(response) {
                var table = $('#table-book-return').DataTable({
                    dom: 'Bfrtip',
                    data: response,
                    columns: [
                        {title: 'ID', data: 'id'},
                        {title: 'Date Return', data: 'date_return'},
                        {title: 'Loan ID', data: 'loan_id'},
                        {title: 'Fine', data: 'fine'},
                        {title: 'Member ID', data: 'member_id'},
                        {title: 'Officer ID', data: 'officer_id'},                        
                    ],
                    buttons: ['pdf', 'excel']
                })

                table.on('click', 'tr', function () { 
                    var selected = table.row(this).data()

                    var modal_actions = $('#modal-actions')
                        modal_actions.modal('open')
                        modal_actions.find('#selected-id').text("ID:"+selected.id+" ISBN:"+selected.isbn)

                    modal_actions.find('ul > a').click(function () { 
                        if($(this).is('#borrow')) {                            
                            borrow(selected)
                        }
                        if($(this).is('#update')) {
                            update(selected)
                        }
                        if($(this).is('#destroy')) {
                            destroy(selected)
                        }
                    })                      
                })
            }
        })
    </script>
@endpush